package nc.bs.bd.pfxx.plugin;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.pfxx.ISwapContext;
import nc.itf.bd.material.assign.IMaterialAssignService;
import nc.itf.bd.material.baseinfo.IMaterialBaseInfoService;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ArrayProcessor;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.errorlog.ErrLogReturnValue;
import nc.vo.bd.errorlog.ErrorMsgVO;
import nc.vo.bd.material.MaterialConvertVO;
import nc.vo.bd.material.MaterialTaxTypeVO;
import nc.vo.bd.material.MaterialVO;
import nc.vo.bd.pub.IPubEnumConst;
import nc.vo.corg.CostRegionVO;
import nc.vo.ic.org.OrgVO;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFDouble;

import org.apache.commons.lang.StringUtils;

/**
 * ϻϢⲿƽ̨
 * 
 * @author jiangjuna
 * @since NC6.0
 */
public class MaterialPfxxPlugin extends nc.bs.pfxx.plugin.AbstractPfxxPlugin {

  private BaseDAO baseDAO = null;

  private IMaterialBaseInfoService service = null;
  
  IUAPQueryBS iUAPQueryBS=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());

  @Override
  protected Object processBill(Object vo, ISwapContext swapContext,
      AggxsysregisterVO aggxsysvo) throws BusinessException {
    String pk = null;
    try {
      MaterialVO materialVO = (MaterialVO) vo;
      String vbillcode = materialVO.getCode();
      String bianma = vbillcode.substring(0, 15);
      String qrybianma = "select thickness_yl,color_yl  from ypff_encoderfile where inventorycode = '"+bianma+"' and nvl(dr,0) = 0";
	  String thickness = (String) iUAPQueryBS.executeQuery(qrybianma, new ColumnProcessor("thickness_yl"));
	  String color = (String) iUAPQueryBS.executeQuery(qrybianma, new ColumnProcessor("color_yl"));
	  //ȡȺ
	  String stname= "select  name From bd_defdoc  where  pk_defdoc=? and  nvl(dr,0)=0 ";
	  Object[] otname = (Object[]) getVo(stname,thickness);
      UFDouble ttname =new UFDouble(otname[0].toString()).div(1000);
      //ȡܶȶ/
      String sds= "select  memo  From bd_defdoc  where  pk_defdoc=? and  nvl(dr,0)=0 ";
	  Object[] ods = (Object[]) getVo(sds,color);
	  UFDouble tds =new UFDouble(ods[0].toString());
	  String t=(ttname.multiply(tds)).toString();
	  
      
      //λ
      String memo = materialVO.getMemo();
      MaterialConvertVO[] vos = materialVO.getMaterialconvert();
      for(MaterialConvertVO convvo : vos){
    	  convvo.setMeasrate("1.00000000/"+t);
      }
    	  
      List<CostRegionVO> costRegionVO=getCostRegion(iUAPQueryBS, memo);
      pk =
          PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(
              swapContext.getBilltype(), swapContext.getDocID());
      if (StringUtils.isBlank(pk)) {
        materialVO = this.insertMaterialVO(materialVO);
        PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(),
            swapContext.getDocID(), materialVO.getPrimaryKey());
        materialVO.setCode(vbillcode);
        materialVO.setMemo("");
        this.getService().updateMaterial(materialVO);
        orgAssign(materialVO, memo, costRegionVO);
        return materialVO.getPrimaryKey();
      }
      this.getService().updateMaterial(this.getUpdateVO(materialVO, pk));
    }
    catch (Exception ex) {
      Logger.error(ex.getMessage(), ex.getCause());
      throw new BusinessException(ex.getMessage(), ex.getCause());
    }
    return pk;
  }
  
  public Object getVo(String sql, String pk) {
		Object ob = null;
		if (pk == null || pk.equals(null)) {
			try {
				ob = (Object) iUAPQueryBS.executeQuery(sql,
						new ArrayProcessor());
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				e.printStackTrace();
			}
			return ob;
		}
		// ȡ֯VO
		SQLParameter param = new SQLParameter(); // 
		param.addParam(pk); // Ӳ
		try {
			ob = (Object) iUAPQueryBS.executeQuery(sql, param,
					new ArrayProcessor());
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		}
		return ob;
	}

  /**
   * 
   * @param vo 
   * @param pkorg ҵ֯
   * @param costRegionVO  ɱ֯
	 * @throws Exception 
   */
	public  void orgAssign(MaterialVO vo,String pkorg,List<CostRegionVO> costRegionVO) throws Exception{
		BaseDAO db=new BaseDAO();
		//ȡ֯Ϣ
		List<OrgVO>  orgVO=getOrgs(iUAPQueryBS, "SYPF-XS");
		String pk_salesorg =orgVO.get(0).getPk_org();
		
		//ɺ֯
		IMaterialAssignService	assignService = ((IMaterialAssignService)NCLocator.getInstance().lookup(IMaterialAssignService.class));
		//assignService.assignMaterialToSelfOrg(vo);//
		vo.setPk_org(pkorg);
		assignService.assignMaterialToSelfOrg(vo);//ҵ֯
		vo.setPk_org(pk_salesorg);
		assignService.assignMaterialToSelfOrg(vo);//֯
		if(costRegionVO.size()!=0){//Ӧɱ֯
			for (int i = 0; i < costRegionVO.size(); i++) {
				vo.setPk_org(costRegionVO.get(i).getPk_costregion());
				assignService.assignMaterialToSelfOrg(vo);
			}	
		}
		try {
			//Ĭȫƽ
			String uct ="update bd_materialcostmod set costmode='4'  where pk_material='"+vo.getPk_material()+"'";
//			iUAPQueryBS.executeQuery(uct,null);
			db.executeUpdate(uct);
		} catch (Exception e2) {
			// TODO: handle exception
		}
		//ȥԶж 
		try {
			String uct ="update bd_materialstock set  isautoatpcheck='N',wholemanaflag ='Y'  where pk_material='"+vo.getPk_material()+"'";
//			iUAPQueryBS.executeQuery(uct,null);
			db.executeUpdate(uct);
			
		} catch (Exception e2) {
			// TODO: handle exception
		}	
		db.executeUpdate("commit;");
	}
	
	//֯ (org_orgs)
	public static List<OrgVO> getOrgs(IUAPQueryBS iUAPQueryBS,String parameters) throws Exception{
		try {
			String sql = "select * From org_orgs  where  pk_org=? and  nvl(dr,0)=0";
			SQLParameter param = new SQLParameter(); // 
			param.addParam(parameters);
			List<OrgVO> list=(List<OrgVO>) iUAPQueryBS.executeQuery(sql, param, new BeanListProcessor(OrgVO.class));
			if(list.size()==0){
				String sql1 = "select * from org_orgs where code=? and nvl(dr,0)=0";
				SQLParameter param1 = new SQLParameter(); // 
				param1.addParam(parameters);
				list=(List<OrgVO>) iUAPQueryBS.executeQuery(sql1, param1, new BeanListProcessor(OrgVO.class));
			}
			if(list.size()==0){
				throw new Exception("δҵ"+parameters+"йصݣ");
			}
			return 	list;
		} catch (Exception e) {
			throw new Exception("ȡ֯Ϣʧ,"+e);
		}
	}
	
	//ȡ֯ɱ
	public static List<CostRegionVO> getCostRegion(IUAPQueryBS iUAPQueryBS,String parameters) throws Exception{
		try {
			String sql = "select * From org_costregion  where  pk_org=? and  nvl(dr,0)=0";
			SQLParameter param = new SQLParameter(); // 
			param.addParam(parameters);
			List<CostRegionVO> list=(List<CostRegionVO>) iUAPQueryBS.executeQuery(sql, param, new BeanListProcessor(CostRegionVO.class));
			if(list.size()==0){
				throw new Exception("δҵ"+parameters+"йصݣ");
			}
			return 	list;
		} catch (Exception e) {
			throw new Exception("ȡ֯ɱϢʧ,"+e);
		}

	}
	
  private BaseDAO getBaseDAO() {
    if (this.baseDAO == null) {
      this.baseDAO = new BaseDAO();
    }
    return this.baseDAO;
  }

  private MaterialVO getInsertVO(MaterialVO materialVO) throws DAOException {
    materialVO.setEnablestate(IPubEnumConst.ENABLESTATE_ENABLE);
    materialVO.setStatus(VOStatus.NEW);
    materialVO.setMaterialconvert(this.getMaterialConvertVOs(materialVO));
    materialVO.setMaterialtaxtype(this.getMaterialTaxTypeVOs(materialVO));
    return materialVO;
  }

  @SuppressWarnings("unchecked")
  private MaterialConvertVO[] getMaterialConvertVOs(MaterialVO MaterialVO)
      throws DAOException {
    List<MaterialConvertVO> newConverts = new ArrayList<MaterialConvertVO>();
    if (StringUtils.isNotBlank(MaterialVO.getPrimaryKey())) {
      Collection<MaterialConvertVO> oldAgentStores =
          this.getBaseDAO().retrieveByClause(
              MaterialConvertVO.class,
              MaterialConvertVO.PK_MATERIAL + " = '"
                  + MaterialVO.getPrimaryKey() + "'", new String[] {
                MaterialConvertVO.PK_MATERIALCONVERT
              });
      for (MaterialConvertVO agentstore : oldAgentStores) {
        agentstore.setStatus(VOStatus.DELETED);
        newConverts.add(agentstore);
      }
    }
    if (MaterialVO.getMaterialconvert()!= null
        && MaterialVO.getMaterialconvert().length > 0) {
      for (MaterialConvertVO agentstore : MaterialVO.getMaterialconvert()) {
        agentstore.setStatus(VOStatus.NEW);
        newConverts.add(agentstore);
      }
    }
    return newConverts.toArray(new MaterialConvertVO[0]);
  }

  private MaterialTaxTypeVO[] getMaterialTaxTypeVOs(MaterialVO MaterialVO)
      throws DAOException {
    List<MaterialTaxTypeVO> newConverts = new ArrayList<MaterialTaxTypeVO>();
    if (StringUtils.isNotBlank(MaterialVO.getPrimaryKey())) {
      Collection<MaterialTaxTypeVO> oldAgentStores =
          this.getBaseDAO().retrieveByClause(
              MaterialTaxTypeVO.class,
              MaterialTaxTypeVO.PK_MATERIAL + " = '"
                  + MaterialVO.getPrimaryKey() + "'", new String[] {
                MaterialTaxTypeVO.PK_MATERIALTAXTYPE
              });
      for (MaterialTaxTypeVO agentstore : oldAgentStores) {
        agentstore.setStatus(VOStatus.DELETED);
        newConverts.add(agentstore);
      }
    }
    if (MaterialVO.getMaterialtaxtype() != null
        && MaterialVO.getMaterialtaxtype().length > 0) {
      for (MaterialTaxTypeVO agentstore : MaterialVO.getMaterialtaxtype()) {
        agentstore.setStatus(VOStatus.NEW);
        newConverts.add(agentstore);
      }
    }
    return newConverts.toArray(new MaterialTaxTypeVO[0]);
  }

  private IMaterialBaseInfoService getService() {
    if (this.service == null) {
      this.service =
          NCLocator.getInstance().lookup(IMaterialBaseInfoService.class);
    }
    return this.service;
  }

  private MaterialVO getUpdateVO(MaterialVO materialVO, String pk)
      throws BusinessException {
    MaterialVO oldVO =
        (MaterialVO) this.getBaseDAO().retrieveByPK(
            MaterialVO.class,
            pk,
            new String[] {
              MaterialVO.CREATOR, MaterialVO.CREATIONTIME,
              MaterialVO.PK_SOURCE, MaterialVO.VERSION, MaterialVO.LATEST,
              MaterialVO.ENABLESTATE
            });
    if (oldVO == null) {
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("bdpub", "0bdpub0057")
      /* @res "ѱɾ" */);
    }
    materialVO.setPrimaryKey(pk);
    materialVO.setCreator(oldVO.getCreator());
    materialVO.setCreationtime(oldVO.getCreationtime());
    materialVO.setPk_source(oldVO.getPk_source());
    materialVO.setVersion(oldVO.getVersion());
    materialVO.setLatest(oldVO.getLatest());
    materialVO.setEnablestate(oldVO.getEnablestate());
    materialVO.setStatus(VOStatus.UPDATED);
    materialVO.setMaterialconvert(this.getMaterialConvertVOs(materialVO));
    materialVO.setMaterialtaxtype(this.getMaterialTaxTypeVOs(materialVO));
    return materialVO;
  }

  private MaterialVO insertMaterialVO(MaterialVO materialVO)
      throws BusinessException, DAOException {
    if (StringUtils.isBlank(materialVO.getPk_source())) {
      materialVO =
          this.getService().insertMaterial(this.getInsertVO(materialVO));
    }
    else {
      ErrLogReturnValue value =
          this.getService().createMaterialVersion(materialVO,
              materialVO.getPk_source());
      if (value.getReturnValue() == null
          || !value.getReturnValue().getClass().isArray()) {
        return materialVO;
      }
      materialVO = (MaterialVO) ((Object[]) value.getReturnValue())[0];
      this.LogErrorMessage(value);
    }
    return materialVO;
  }

  private void LogErrorMessage(ErrLogReturnValue value) {
    ErrorMsgVO[] vos = value.getErrLogResult().getErrorMsgs();
    if (vos != null && vos.length > 0) {
      String message =
          nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID(
              "10140mag",
              "010140mag0200",
              null,
              new String[] {
                Integer.toString(value.getTotalNum()),
                Integer.toString(value.getErrLogResult().getErrorMessagegNum())
              })
              /* @res "ⲿƽ̨°汾ʱֳɹ{0}¼{1}ʧܣ" */+ "\n";
      for (int i = 0; i < vos.length; i++) {
        message += vos[i].getErrormsg() + "\n";
      }
      Logger.debug(message);
    }
  }

}
