package nc.pubimpl.so.m30.pfxx;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.taskmanager.SynTaskTree;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.impl.pubapp.pattern.data.bill.tool.BillConcurrentTool;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.impl.so.m30.action.main.InsertSaleOrderAction;
import nc.impl.so.m30.action.main.UpdateSaleOrderAction;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.pubimpl.so.pfxx.AbstractSOPfxxPlugin;
import nc.pubimpl.so.pfxx.check.BillFreeStatusCheckRule;
import nc.pubimpl.so.pfxx.check.MnyTaxCheckRule;
import nc.pubimpl.so.pfxx.check.WriteBackInfoCheckRule;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.so.m30.entity.SaleOrderBVO;
import nc.vo.so.m30.entity.SaleOrderHVO;
import nc.vo.so.m30.entity.SaleOrderVO;
import nc.vo.wfengine.pub.WFTask;

public class M30PfxxPlugin extends AbstractSOPfxxPlugin {
	
	IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());

  @Override
  public List<IRule<AggregatedValueObject>> getCheckers() {
    List<IRule<AggregatedValueObject>> rules =
        new ArrayList<IRule<AggregatedValueObject>>();
    // ״̬飬̬Ե
    rules.add(new BillFreeStatusCheckRule());
    // ˰ϼ=˰+˰ң
//    rules.add(new MnyTaxCheckRule(SaleOrderBVO.NTAX, SaleOrderBVO.NMNY,
//        SaleOrderBVO.NTAXMNY));
    // ۼֶ
    rules.add(new WriteBackInfoCheckRule(new String[] {
      SaleOrderBVO.NTOTALSENDNUM,// ۼƷ
      SaleOrderBVO.NTOTALINVOICENUM,// ۼƿƱ
      SaleOrderBVO.NTOTALOUTNUM,// ۼƳ
      SaleOrderBVO.NTOTALNOTOUTNUM,// ۼӦδ
      SaleOrderBVO.NTOTALSIGNNUM,// ۼǩ
      SaleOrderBVO.NTRANSLOSSNUM,// ۼ;
      SaleOrderBVO.NTOTALRUSHNUM,// ۼƳԳ
      SaleOrderBVO.NTOTALESTARNUM,// ۼݹӦ
      SaleOrderBVO.NTOTALARNUM,// ۼȷӦ
      SaleOrderBVO.NTOTALCOSTNUM,// ۼƳɱ
      SaleOrderBVO.NTOTALESTARMNY,// ۼݹӦս
      SaleOrderBVO.NTOTALARMNY,// ۼȷӦս
      SaleOrderBVO.NTOTALPAYMNY,// ۼտ
      SaleOrderBVO.NORIGSUBMNY,// ۼƳֽ
      SaleOrderBVO.NARRANGESCORNUM,// ۼưίⶩ
      SaleOrderBVO.NARRANGEPOAPPNUM,// ۼư빺
      SaleOrderBVO.NARRANGETOORNUM,// ۼưŵ
      SaleOrderBVO.NARRANGETOAPPNUM,// ۼưŵ
      SaleOrderBVO.NARRANGEMONUM,// ۼư
      SaleOrderBVO.NARRANGEPONUM,// ۼưŲɹ
      SaleOrderBVO.NTOTALPLONUM,// ۼɼƻ
      SaleOrderBVO.NTOTALRETURNNUM,// ۼ˻
      SaleOrderBVO.NTOTALTRADENUM
    // ۼƷƷ
        }));
    return rules;
  }

  @Override
  protected AggregatedValueObject insert(AggregatedValueObject vo) {

    SaleOrderVO[] insertvo = new SaleOrderVO[] {
      (SaleOrderVO) vo
    };

	/*ֻ */
	
	 /**
     * ԴĿıѯָڵĻ
     * 
     * @param src_currency_pk
     *            Դ
     * @param dest_currency_pk
     *            ĿıֵΪnullʱΪĬĿı
     * @param date
     * @return
     * @throws BusinessException
     */
	

    SaleOrderHVO headvo=(SaleOrderHVO) vo.getParentVO();
 //    if( headvo.getNexchangerate().compareTo(UFDouble.ONE_DBL)!=0){
 		String corigcurrencyid= headvo.getCorigcurrencyid();
 		String ccustomerid = headvo.getCcustomerid();//ͻ
 		String tempcpaytermid = headvo.getCpaytermid();
 		try {
			String cpaytermid = SqlexecuteQuery(ccustomerid,tempcpaytermid);//տЭ
			headvo.setCpaytermid(cpaytermid);
		} catch (Exception e2) {
			// TODO Զɵ catch 
			e2.printStackTrace();
		}
 		
 		CurrencyRateUtil currRateUtil = CurrencyRateUtil
 				.getInstanceByOrg(headvo.getPk_org());
 		try {
 			SaleOrderBVO[]  bodyvos= (SaleOrderBVO[]) vo.getChildrenVO();
 			for(SaleOrderBVO bodyvo:bodyvos){
 				String ccurrencyid= bodyvo.getCcurrencyid();
 				
 				if(corigcurrencyid.equals(ccurrencyid)){
 					UFDouble nnum = bodyvo.getNnum();//
 					UFDouble nastnum = bodyvo.getNastnum();//
 					UFDouble vchangerate = nastnum.div(nnum);//λ
 					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
 					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
 					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
 					UFDouble norigtaxprice = vchangerate.multiply(nqtorigtaxprice);//˰
 					UFDouble norigprice = vchangerate.multiply(nqtorigprice);//˰
 					bodyvo.setNqtunitnum(nnum);//
 					bodyvo.setVqtunitrate("1.00000000/1.00000000");//ۻ
 					bodyvo.setNqtorigtaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorignetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorignetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNcaltaxmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxmny(norigtaxmny.setScale(2, UFDouble.ROUND_HALF_UP));//˰ϼ
 					bodyvo.setNqttaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqttaxnetprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtnetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNnetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxmny(nastnum.multiply(nqtorigtaxprice).setScale(2, UFDouble.ROUND_HALF_UP));//Ҽ˰ϼ
 					//˰
 					bodyvo.setNtax(bodyvo.getNtaxmny().sub(bodyvo.getNmny()));//˰
 					
 					continue;
 				}
 				else{
 					UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,/*ԭ*/
 	 	 					ccurrencyid/**/, headvo.getDbilldate());//
 	 				bodyvo.setNexchangerate(foreignrate);//۱
 	 				UFDouble nnum = bodyvo.getNnum();//
 					UFDouble nastnum = bodyvo.getNastnum();//
 					UFDouble vchangerate = nastnum.div(nnum);//λ
 					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
 					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
 					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
 					UFDouble norigtaxprice = vchangerate.multiply(nqtorigtaxprice);//˰
 					UFDouble norigprice = vchangerate.multiply(nqtorigprice);//˰
 					UFDouble nqtprice =	currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, nqtorigprice, foreignrate, headvo.getDbilldate());//˰
 					UFDouble nqttaxprice =	currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, nqtorigtaxprice, foreignrate, headvo.getDbilldate());//Һ˰
 					UFDouble ntaxprice = currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, norigtaxprice, foreignrate, headvo.getDbilldate());//Һ˰
 					UFDouble nprice = currRateUtil.getAmountByOpp(corigcurrencyid,
 	 						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());//˰
 					bodyvo.setNqtunitnum(nnum);//
 					bodyvo.setVqtunitrate("1.00000000/1.00000000");//ۻ
 					bodyvo.setNqtorigtaxprice(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqtorignetprice(nqtorigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxnetprice(norigtaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorignetprice(norigprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNcaltaxmny(nastnum.multiply(nqtprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigmny(nastnum.multiply(nqtorigprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNorigtaxmny(norigtaxmny.setScale(2, UFDouble.ROUND_HALF_UP));//˰ϼ
 					bodyvo.setNqttaxprice(nqttaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtprice(nqtprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNqttaxnetprice(nqttaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNqtnetprice(nqtprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxprice(ntaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNprice(nprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxnetprice(ntaxprice.setScale(4, UFDouble.ROUND_HALF_UP));//Һ˰
 					bodyvo.setNnetprice(nprice.setScale(4, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNmny(nastnum.multiply(nqtprice).setScale(2, UFDouble.ROUND_HALF_UP));//˰
 					bodyvo.setNtaxmny(nastnum.multiply(nqttaxprice).setScale(2, UFDouble.ROUND_HALF_UP));//Ҽ˰ϼ
 					//˰
 					bodyvo.setNtax(bodyvo.getNtaxmny().sub(bodyvo.getNmny()));//˰
 				}
 			}
 			
 		} catch (BusinessException e1) {
 			 ExceptionUtils.wrappException(e1);
              return null;
 		}
	
	  InsertSaleOrderAction insertact = new InsertSaleOrderAction();
	  InvocationInfoProxy.getInstance().setUserId(insertvo[0].getParentVO().getBillmaker());
	    SaleOrderVO[] retvos = insertact.insert(insertvo);
	    if (null == retvos || retvos.length == 0) {
	      return null;
	    }
	    
	    
    
    //add by ZTH Ź ۶ͨ  
    
	String pk_org = retvos[0].getParentVO().getPk_org();
	//0001V510000000002GEH   Ż				
	if(pk_org != null && (pk_org.equals("0001V510000000002GDX"))){
	 IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
	 InvocationInfoProxy.getInstance().setUserId(retvos[0].getParentVO().getApprover());
	    try {
	    	service.processAction(IPFActionName.APPROVE,
			     "30", null, retvos[0], null, null);
		} catch (BusinessException e) {
			// TODO Զɵ catch 
			ExceptionUtils.wrappBusinessException(e.getMessage());
		    return null;
		}
	}	
    
    

  
    
    return retvos[0];
  }

  @Override
  protected AggregatedValueObject update(AggregatedValueObject vo, String vopk) {

    SaleOrderVO[] updatevo = new SaleOrderVO[] {
      (SaleOrderVO) vo
    };
    BillQuery<SaleOrderVO> billquery =
        new BillQuery<SaleOrderVO>(SaleOrderVO.class);
    SaleOrderVO[] origvos = billquery.query(new String[] {
      vopk
    });
    BillConcurrentTool tool = new BillConcurrentTool();
    tool.lockBill(origvos);
    UpdateSaleOrderAction insertact = new UpdateSaleOrderAction();
    SaleOrderVO[] retvos = insertact.update(updatevo, origvos);
    if (null == retvos || retvos.length == 0) {
      return null;
    }
    return retvos[0];
  }
  
  /**
   * 
   * @param ccustomerid
   * @param pk_org
   * @return
   * @throws Exception
   */
  private String SqlexecuteQuery(String ccustomerid,String pk_org) throws Exception {
		
		String sql = "select pk_payterm from bd_custfinance where pk_customer = '"+ccustomerid+"' and pk_org = '"+pk_org+"' and nvl(dr,0)=0";
		
		Object object;
		try {
			object = iuap.executeQuery(sql, new ColumnProcessor());
			if (object==null) {
				return "";
			}
			
			return object.toString();
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return e.getMessage();
		}
	}

}
