package nc.bs.ic.general.plugins;

import java.util.ArrayList;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.bs.ic.pub.env.ICBSContext;
import nc.bs.logging.Logger;
import nc.bs.pfxx.ISwapContext;
import nc.bs.pfxx.plugin.AbstractPfxxPlugin;
import nc.impl.ic.util.DateCalUtil;
import nc.impl.pubapp.pattern.data.vo.VOQuery;
import nc.itf.mmpac.pmo.pac0002.IPMOMaintainService;
import nc.itf.mmpac.pmo.pac0002.IPMOTransTypeQueryService;
import nc.itf.scmpub.reference.uap.pf.PfServiceScmUtil;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.processor.ArrayListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.ia.mi4.entity.I4BillVO;
import nc.vo.ia.mi4.entity.I4ItemVO;
import nc.vo.ic.general.define.ICBillBodyVO;
import nc.vo.ic.general.define.ICBillFlag;
import nc.vo.ic.general.define.ICBillHeadVO;
import nc.vo.ic.general.define.ICBillVO;
import nc.vo.ic.general.define.MetaNameConst;
import nc.vo.ic.general.util.InOutHelp;
import nc.vo.ic.m45.entity.PurchaseInBodyVO;
import nc.vo.ic.m45.entity.PurchaseInHeadVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.ic.m46.entity.FinProdInBodyVO;
import nc.vo.ic.m46.entity.FinProdInHeadVO;
import nc.vo.ic.m46.entity.FinProdInVO;
import nc.vo.ic.m4a.entity.GeneralInBodyVO;
import nc.vo.ic.m4a.entity.GeneralInHeadVO;
import nc.vo.ic.m4a.entity.GeneralInVO;
import nc.vo.ic.m4c.entity.SaleOutBodyVO;
import nc.vo.ic.m4c.entity.SaleOutHeadVO;
import nc.vo.ic.m4c.entity.SaleOutVO;
import nc.vo.ic.m4d.entity.MaterialOutBodyVO;
import nc.vo.ic.m4d.entity.MaterialOutHeadVO;
import nc.vo.ic.m4d.entity.MaterialOutVO;
import nc.vo.ic.m4i.entity.GeneralOutBodyVO;
import nc.vo.ic.m4i.entity.GeneralOutHeadVO;
import nc.vo.ic.m4i.entity.GeneralOutVO;
import nc.vo.ic.m4k.entity.WhsTransBillBodyVO;
import nc.vo.ic.m4k.entity.WhsTransBillHeaderVO;
import nc.vo.ic.m4k.entity.WhsTransBillVO;
import nc.vo.ic.m4q.entity.LocAdjustBodyVO;
import nc.vo.ic.m4q.entity.LocAdjustHeadVO;
import nc.vo.ic.m4q.entity.LocAdjustVO;
import nc.vo.ic.pub.define.ICBillTableInfo;
import nc.vo.ic.pub.define.ICPubMetaNameConst;
import nc.vo.ic.pub.util.StringUtil;
import nc.vo.ic.pub.util.ValueCheckUtil;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.workflow.IPFActionName;
import nc.vo.pubapp.calculator.CalculatorUtil;
import nc.vo.pubapp.calculator.formula.SummnyMoneyTaxFormula;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import nc.vo.pubapp.scale.ScaleUtils;
import nc.vo.pubapp.util.VORowNoUtils;
import nc.vo.to.m5x.entity.BillHeaderVO;
import nc.vo.to.m5x.entity.BillItemVO;
import nc.vo.to.m5x.entity.BillVO;

/**
 * ⲿƽ̨ⲿͨݴ
 * 
 * @since 6.0
 * @version 2011-4-25 04:07:36
 * @author wanghna
 */
public class GeneralDefdocPlugin extends AbstractPfxxPlugin {
   
  @Override
  protected Object processBill(Object vo, ISwapContext swapContext,
      AggxsysregisterVO aggxsysvo) throws BusinessException {

    if (vo == null)
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("4008001_0", "04008001-0137")/*@res "תvoΪ"*/);
    /**
     * ۳
     */
    if(vo instanceof SaleOutVO){
    	SaleOutVO saleoutvo = (SaleOutVO) vo;
    	SaleOutHeadVO headvo = saleoutvo.getHead();
    	SaleOutBodyVO[] bodyvos = saleoutvo.getBodys();
    	CurrencyRateUtil currRateUtil = CurrencyRateUtil
				.getInstanceByOrg(headvo.getPk_org());
    	for(SaleOutBodyVO bodyvo : bodyvos){
    		String corigcurrencyid = bodyvo.getCorigcurrencyid();//ԭ
        	String ccurrencyid= bodyvo.getCcurrencyid();//λ
        	try {
    			if(corigcurrencyid.equals(ccurrencyid)){
    					UFDouble nqtorigtaxprice = bodyvo.getNqtorigtaxprice();//˰
    					UFDouble nqtorigprice = bodyvo.getNqtorigprice();//˰
    					UFDouble norigmny = bodyvo.getNorigmny();//˰
    					UFDouble norigtaxmny = bodyvo.getNorigtaxmny();//˰ϼ
    					bodyvo.setNcaltaxmny(norigtaxmny);//˰
    					bodyvo.setNqttaxprice(nqtorigtaxprice);//Һ˰
    					bodyvo.setNqtprice(nqtorigprice);//˰
    					bodyvo.setNqttaxnetprice(nqtorigtaxprice);//Һ˰
//    					bodyvo.setNorigtaxnetprice(nqtorigtaxprice);//˰
//    					bodyvo.setNorignetprice(nqtorigprice);//˰
    					bodyvo.setNqtnetprice(nqtorigprice);//˰
//    					bodyvo.setNtaxprice(nqtorigtaxprice);//Һ˰
    					bodyvo.setNpiece(nqtorigprice);//˰
//    					bodyvo.setNtaxnetprice(nqtorigtaxprice);//Һ˰
    					bodyvo.setNorigtaxnetprice(nqtorigtaxprice);//˰
    					bodyvo.setNorignetprice(nqtorigprice);//˰
    					bodyvo.setNnetprice(nqtorigprice);//˰
    					bodyvo.setNmny(norigmny);//˰
    					bodyvo.setNtaxmny(norigtaxmny);//Ҽ˰ϼ
    					bodyvo.setNqtorigtaxnetprc(nqtorigtaxprice);//˰
    					bodyvo.setNqtorignetprice(nqtorigprice);//˰
    					continue;
    				}
    				UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,/*ԭ*/
    						ccurrencyid/**/, headvo.getDbilldate());//
    				bodyvo.setNchangestdrate(foreignrate);
    				//norigprice ԭ˰
    				UFDouble norigprice=bodyvo.getNorigtaxprice();//ԭҺ˰
    				UFDouble foreignAmount=	currRateUtil.getAmountByOpp(corigcurrencyid,
    						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());
//    				bodyvo.setNtaxprice(foreignAmount);//Һ˰
    				UFDouble ngprice=currRateUtil.getAmountByOpp(corigcurrencyid,
    						ccurrencyid, bodyvo.getNorigprice()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
    				bodyvo.setNprice(ngprice); // ˰
    				bodyvo.setNqtprice(ngprice); //۱˰
    				bodyvo.setNqttaxprice(foreignAmount);//۱Һ˰
    				UFDouble nmny=currRateUtil.getAmountByOpp(corigcurrencyid,
    						ccurrencyid, bodyvo.getNorigmny()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
    				bodyvo.setNmny(nmny);//˰  
    				UFDouble ntaxmny=currRateUtil.getAmountByOpp(corigcurrencyid,
    						ccurrencyid, bodyvo.getNorigtaxmny()/*ԭҼ˰ϼ*/, foreignrate, headvo.getDbilldate());
    				bodyvo.setNtaxmny(ntaxmny);//ntaxmny Ҽ˰ϼ
    				bodyvo.setNcaltaxmny(ntaxmny);//˰
    				bodyvo.setNqtnetprice(ngprice);//˰
    				bodyvo.setNnetprice(ngprice);//˰
    				bodyvo.setNorignetprice(ngprice);//˰
    				bodyvo.setNqttaxnetprice(foreignAmount);//Һ˰
//    				bodyvo.setNorigtaxnetprice(foreignAmount);//˰
//    				bodyvo.setNorignetprice(ngprice);//˰
//    				bodyvo.setNtaxnetprice(foreignAmount);//Һ˰
    				bodyvo.setNorigtaxnetprice(foreignAmount);//˰
    				bodyvo.setNtax(ntaxmny.sub(nmny));//˰=˰ϼ-˰
    				bodyvo.setNqtorigtaxnetprc(foreignAmount);//˰
    				bodyvo.setNqtorignetprice(ngprice);//˰
    				
    				
    				bodyvo.setNorignetprice(bodyvo.getNorigprice());//˰
    				bodyvo.setNorigtaxnetprice(bodyvo.getNorigtaxprice());//˰
    				bodyvo.setNtaxnetprice(bodyvo.getNorigtaxprice());//Һ˰
    				bodyvo.setNtaxprice(bodyvo.getNorigtaxprice());//Һ˰
    		} catch (BusinessException e) {
    			// TODO Զɵ catch 
    			ExceptionUtils.wrappBusinessException(e.getMessage());
    		}
    	}
    }
    /**
     * add by ZTH
     * 2021-07-16
     *  
     */
    if(vo instanceof FinProdInVO ){  //Ʒ
    	FinProdInVO finvo=(FinProdInVO) vo;
    	FinProdInBodyVO [] bodyvos=(FinProdInBodyVO[]) finvo.getChildrenVO();
    	FinProdInHeadVO  headvo=(FinProdInHeadVO) finvo.getParentVO();
    	for(FinProdInBodyVO byvo: bodyvos){
    		UFDate dproducedate=byvo.getDproducedate();//
    		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
    		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
    		Object materialvid = disposeMaterialVersions(byvo.getCmaterialvid());
    		Object materialoid = disposeMaterialVersions2(byvo.getCmaterialoid());
    		Object cfirstbillhid = setCbmoid(byvo.getVfirstbillcode());//ͷ
      		Object cfirstbillbid = setCbmobid(byvo.getVfirstbillcode());//
    		Object csourcebillhid = setMm_wrPK(byvo.getVsourcebillcode());//
    		Object csourcebillbid = setMm_wr_productPK(byvo.getVsourcebillcode());//
    		byvo.setCfirstbillhid((String) cfirstbillhid);
    		byvo.setCfirstbillbid((String) cfirstbillbid);
    		byvo.setCsourcebillhid((String) csourcebillhid);
    		byvo.setCsourcebillbid((String) csourcebillbid);
    		byvo.setCmaterialvid((String) materialvid);//϶汾
    		byvo.setCmaterialoid((String) materialoid);//ϵ汾
    		byvo.setCproductid((String) materialoid);//Ʒ
    		byvo.setClocationid((String) rack);//λ
    		if(null!=qualityNumpbj&&null!=dproducedate){
    			Integer qualityNum=(Integer) qualityNumpbj;
    			UFDate dvalidate =
    	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
    	    		 byvo.setDvalidate(dvalidate);
    		}
    	}
     }else if(vo instanceof PurchaseInVO ){		//ɹ
    	PurchaseInVO  finvo=(PurchaseInVO) vo;
    	PurchaseInBodyVO  [] bodyvos=(PurchaseInBodyVO[]) finvo.getChildrenVO();
    	PurchaseInHeadVO headvo = (PurchaseInHeadVO) finvo.getParentVO();
    	for(PurchaseInBodyVO byvo: bodyvos){
    		UFDate dproducedate=byvo.getDproducedate();//   
    		UFDouble ntaxmny = bodydisposenorigtaxmny(byvo.getPk_group(), byvo.getNqtorigtaxprice(), byvo.getNassistnum(), byvo.getCorigcurrencyid());
    		UFDouble nmny = bodydisposenorigmny(byvo.getPk_group(), byvo.getNqtorigtaxprice(), byvo.getNtaxrate(), byvo.getNassistnum(), byvo.getCorigcurrencyid());
    		byvo.setNtaxmny(ntaxmny);//Ҽ˰ϼ
    		byvo.setNorigtaxmny(ntaxmny);//˰ϼ
    		byvo.setNmny(nmny);//˰
    		byvo.setNorigmny(nmny);//˰
    		byvo.setNcalcostmny(nmny);//Ƴɱ
    		byvo.setNtax(CalculatorUtil.sub(ntaxmny,nmny));//˰
    		byvo.setNcaltaxmny(CalculatorUtil.sub(ntaxmny,nmny));//˰˰
    		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
    		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
    		Object material = disposeMaterialVersions(byvo.getCmaterialvid());
    		byvo.setCmaterialvid((String) material);//϶汾
    		//add by ZTH 2022-09-22 ޸ϱΪϰ汾
    		byvo.setCmaterialoid((String) disposeMaterialVersions2(byvo.getCmaterialvid()));
    		
    		
    		byvo.setClocationid((String) rack);//λ
    		if(null!=qualityNumpbj&&null!=dproducedate){
    			Integer qualityNum=(Integer) qualityNumpbj;
    			UFDate dvalidate =
    	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
    	    		 byvo.setDvalidate(dvalidate);
    		}
    	}
     }else if(vo instanceof GeneralInVO ){   //  ic_generalin_h
    	GeneralInVO  finvo=(GeneralInVO ) vo;
    	GeneralInBodyVO  [] bodyvos=(GeneralInBodyVO[]) finvo.getChildrenVO();
    	GeneralInHeadVO headvo = (GeneralInHeadVO) finvo.getParentVO();
    	for(GeneralInBodyVO byvo: bodyvos){
    		UFDate dproducedate=byvo.getDproducedate();//
    		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
    		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
    		byvo.setClocationid((String) rack);//λ
    		if(null!=qualityNumpbj&&null!=dproducedate){
    			Integer qualityNum=(Integer) qualityNumpbj;
    			UFDate dvalidate =
    	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
    	    		 byvo.setDvalidate(dvalidate);
    		}
    	}
      }else if(vo instanceof GeneralOutVO ){  //   ic_generalout_h
    	 GeneralOutVO  finvo=(GeneralOutVO) vo;
    	 GeneralOutBodyVO [] bodyvos=(GeneralOutBodyVO[]) finvo.getChildrenVO();
    	 GeneralOutHeadVO headvo = (GeneralOutHeadVO) finvo.getParentVO();
  		 for(GeneralOutBodyVO byvo: bodyvos){
     		UFDate dproducedate=byvo.getDproducedate();//
     		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
     		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
    		byvo.setClocationid((String) rack);//λ
     		if(null!=qualityNumpbj&&null!=dproducedate){
     			Integer qualityNum=(Integer) qualityNumpbj;
     			UFDate dvalidate =
     	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
     	    		 byvo.setDvalidate(dvalidate);
     		}
  		 }
     }else if(vo instanceof MaterialOutVO ){  //ϳ
    	 MaterialOutVO  finvo=(MaterialOutVO) vo;
    	 MaterialOutBodyVO [] bodyvos=(MaterialOutBodyVO[]) finvo.getChildrenVO();
    	 MaterialOutHeadVO headvo = (MaterialOutHeadVO) finvo.getParentVO();
    	 for(MaterialOutBodyVO byvo: bodyvos){
      		UFDate dproducedate=byvo.getDproducedate();//
      		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
      		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
      		Object cfirstbillhid = setCbmoid(byvo.getVfirstbillcode());//ͷ
      		Object cfirstbillbid = setCbmobid(byvo.getVfirstbillcode());//
      		Object mm_pickmpk = setMm_pickmPK(byvo.getVfirstbillcode());//ϼƻPK
      		Object pickmvbillcode = setPickmvbillcode(byvo.getVfirstbillcode());//ϼƻ
      		Object pickmvbusitype = setPickmvbusitype(byvo.getVfirstbillcode());//ϼƻ
      		Object pickm_bpk = setPickm_bPK(byvo.getVfirstbillcode());//ϼƻPK
      		Object pickm_bvrowno = setPickm_bvrowno(byvo.getVfirstbillcode());//ϼƻк
      		byvo.setCsourcebillhid((String) mm_pickmpk);
      		byvo.setVsourcebillcode((String) pickmvbillcode);
      		byvo.setCsourcetranstype((String) pickmvbusitype);
      		byvo.setCsourcebillbid((String) pickm_bpk);
      		byvo.setVsourcerowno((String) pickm_bvrowno);
      		byvo.setCfirstbillhid((String) cfirstbillhid);
      		byvo.setCfirstbillbid((String) cfirstbillbid);
    		byvo.setClocationid((String) rack);//λ
    		//add by PCY 2022-11-25 ޸ϱΪϰ汾
    		byvo.setCmaterialoid((String) disposeMaterialVersions2(byvo.getCmaterialvid()));
      		if(null!=qualityNumpbj&&null!=dproducedate){
      			Integer qualityNum=(Integer) qualityNumpbj;
      			UFDate dvalidate =
      	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
      	    		 byvo.setDvalidate(dvalidate);
      		}
    	 }
    	 
     }else if(vo instanceof WhsTransBillVO ){  //תⵥ
    	 WhsTransBillVO finvo=(WhsTransBillVO) vo;
    	 WhsTransBillBodyVO  [] bodyvos=(WhsTransBillBodyVO[]) finvo.getChildrenVO();
    	 WhsTransBillHeaderVO headvo = (WhsTransBillHeaderVO) finvo.getParentVO();
    	 for(WhsTransBillBodyVO byvo: bodyvos){
       		UFDate dproducedate=byvo.getDproducedate();//
       		Object qualityNumpbj=getbzjinfo(byvo.getCmaterialoid(),byvo.getPk_org());
       		Object rack = bodytranslaterack(headvo.getCwarehouseid() , byvo.getPk_org(), byvo.getClocationid());
    		byvo.setClocationid((String) rack);//λ
       		if(null!=qualityNumpbj&&null!=dproducedate){
       			Integer qualityNum=(Integer) qualityNumpbj;
       			UFDate dvalidate =
       	       	          DateCalUtil.calDvalidate(dproducedate, qualityNum, 2);
       	    		 byvo.setDvalidate(dvalidate);
       		}
    	 }
     }
    
    String vopk =
        PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(
            swapContext.getBilltype(), swapContext.getDocID(),
            swapContext.getOrgPk());

    if (!StringUtil.isSEmptyOrNull(vopk) && !this.canUpdate())
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("4008001_0", "04008001-0138")/*@res "ǰǰ"*/);
    // TODO Ƿ
    // PfxxPluginUtils.checkBillCanBeUpdate(UfinterfaceVO swapContext);

    ICBillVO icbill = (ICBillVO) vo;
    icbill.getHead().setCgeneralhid(vopk);

    ICBillVO[] icbills = null;
    if (ValueUtils.getBoolean(swapContext.getReplace()))
      icbills = this.doUpdate(swapContext, icbill);
    else
      icbills = this.doSave(swapContext, icbill);

    return icbills[0].getHead().getCgeneralhid();
  }

  /**
   * 
   * 
   * @param swapContext
   * @param icbill
   * @return
   * @throws BusinessException
   */
  private ICBillVO[] doSave(ISwapContext swapContext, ICBillVO icbill)
      throws BusinessException {
    //Ƿ
    this.checkCanInster(icbill);
    Logger.info("µǰ...");
    this.processBeforeSave(icbill);

    // TODO иϢaggxsysvoΪûõľ帨Ϣ

    Logger.info("µ...");
    IPFBusiAction service = NCLocator.getInstance().lookup(IPFBusiAction.class);
    ICBillVO[] icbills =
        (ICBillVO[]) service.processAction(IPFActionName.WRITE,
            swapContext.getBilltype(), null, icbill, null, null);
    
    
/*    //add by ZTH Źͨ   
	String pk_org = icbills[0].getParentVO().getPk_org();
	//0001V510000000001XCM   ϺҫƤ̲޹˾
	//0001V510000000002GFN   ҫƤ̲޹˾
	//0001V510000000002GF2      ҫƤ̲޹˾
	//0001V510000000002GEH   ҫƤ̲޹˾					
	if(pk_org != null && (pk_org.equals("0001V510000000001XCM") 
			|| pk_org.equals("0001V510000000002GFN")
			|| pk_org.equals("0001V510000000002GF2")
			|| pk_org.equals("0001V510000000002GEH"))){
		if(swapContext.getBilltype().equals("46")){
			icbills =
		            (ICBillVO[]) service.processAction("SIGN",
		                "46", null, icbill, null, null);
		}
		else if(swapContext.getBilltype().equals("4C")){
			icbills =
		            (ICBillVO[]) service.processAction("SIGN",
		                "4C", null, icbill, null, null);
		}
		else{
			icbills =
		            (ICBillVO[]) service.processAction(IPFActionName.APPROVE,
		                swapContext.getBilltype(), null, icbill, null, null);
		}
	}	*/
    
    

    Logger.info("µ...");

    Logger.info("µݺ...");
    this.processAfterSave(icbill);

    if (ValueCheckUtil.isNullORZeroLength(icbills))
      return null;

    if (this.canUpdate())
      PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(),
          swapContext.getDocID(), swapContext.getOrgPk(), icbills[0].getHead()
              .getCgeneralhid());
    
    
    
    
    
    return icbills;
  }

  /**
   * ޸ģɾ
   * 
   * @param swapContext
   * @param icbill
   * @return
   * @throws BusinessException
   */
  private ICBillVO[] doUpdate(ISwapContext swapContext, ICBillVO icbill)
      throws BusinessException {
    ICBillVO bill = getOriBillVO(icbill, swapContext.getBilltype());
    if (bill != null) {
      IPFBusiAction service =
          NCLocator.getInstance().lookup(IPFBusiAction.class);
      service.processAction(IPFActionName.DEL_DELETE,
          swapContext.getBilltype(), null, bill, null, null);
    }
    return this.doSave(swapContext, icbill);
  }

  /**
   * ݵݺŻѴڵvo
   * 
   * @param icbill
   * @param billtype
   * @return
   */
  private ICBillVO getOriBillVO(ICBillVO icbill, String billtype) {
    if (StringUtil.isSEmptyOrNull(icbill.getHead().getVbillcode()))
      return null;
    SqlBuilder where = new SqlBuilder();
    where.append(" and ");
    where.append(ICPubMetaNameConst.VBILLCODE, icbill.getHead().getVbillcode());
    where.append(" and ");
    where.append(ICPubMetaNameConst.PK_GROUP, icbill.getHead().getPk_group());
    // where.append(" and ");
    // where.append(ICPubMetaNameConst.PK_ORG,icbill.getHead().getPk_org());

    ICBillTableInfo billinfo =
        ICBillTableInfo.getICBillTableInfo(InOutHelp.getICBillType(billtype));
    VOQuery<ICBillHeadVO> query =
        new VOQuery<ICBillHeadVO>(billinfo.getHeadClass(), new String[] {
          MetaNameConst.CGENERALHID, ICPubMetaNameConst.TS
        });
    ICBillHeadVO[] heads = query.query(where.toString(), null);
    if (ValueCheckUtil.isNullORZeroLength(heads))
      return null;
    where = new SqlBuilder();
    where.append(" and ");
    where.append(MetaNameConst.CGENERALHID, heads[0].getCgeneralhid());
    VOQuery<ICBillBodyVO> bodyquery =
        new VOQuery<ICBillBodyVO>(billinfo.getBodyClass(), new String[] {
          MetaNameConst.CGENERALHID, MetaNameConst.CGENERALBID,
          ICPubMetaNameConst.TS
        });
    ICBillBodyVO[] bodys = bodyquery.query(where.toString(), null);
    if (ValueCheckUtil.isNullORZeroLength(bodys))
      return null;

    ICBillVO bill = billinfo.createBillVO();
    bill.setParent(heads[0]);
    bill.setChildrenVO(bodys);
    return bill;
  }

  /**
   * ݱǰ
   * 
   * @param vo
   */
  protected void processBeforeSave(ICBillVO vo) throws BusinessException {

    if (null == vo)
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("4008001_0", "04008001-0139")/*@res "ݲΪ"*/);

    // this.checkNullValue(vo);
    // ͷ֯ûиֵҪرֶȡһ
      if(StringUtil.isSEmptyOrNull(vo.getParentVO().getPk_org()))
      vo.getParentVO().setPk_org(vo.getBodys()[0].getPk_org());
      if(StringUtil.isSEmptyOrNull(vo.getParentVO().getPk_org_v()))
      vo.getParentVO().setPk_org_v(vo.getBodys()[0].getPk_org_v());
      if(StringUtil.isSEmptyOrNull(vo.getParentVO().getCwarehouseid()))
      vo.getParentVO().setCwarehouseid(vo.getBodys()[0].getCbodywarehouseid());

    ICBSContext context = new ICBSContext();
    this.headVOProcess(vo.getHead(), context);
    this.bodyVOProcess(vo, context);
  }

  /**
   * ݱ
   * 
   * @param vo
   */
  protected void processAfterSave(ICBillVO vo) throws BusinessException {
    if (null == vo)
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("4008001_0", "04008001-0140")/*@res "ݱʧ"*/);
  }

  /**
   * ͷĬֵ˾ڣ״̬ӡ
   * 
   * @param vo
   */
  private void headVOProcess(ICBillHeadVO vo, ICBSContext context) {
    vo.setStatus(VOStatus.NEW);
    // 
    if (StringUtil.isSEmptyOrNull(vo.getPk_group()))
      vo.setPk_group(context.getPk_group());
    // ӡ
    if (vo.getIprintcount() == null)
      vo.setIprintcount(Integer.valueOf(0));
    // ״̬
    if (vo.getFbillflag() == null)
      vo.setFbillflag((Integer) ICBillFlag.FREE.value());
    // 
    if (vo.getDbilldate() == null)
      vo.setDbilldate(context.getBizDate());
    // ˾
    if (StringUtil.isSEmptyOrNull(vo.getCorpoid())
        || StringUtil.isSEmptyOrNull(vo.getCorpvid())) {
      vo.setCorpoid(context.getOrgInfo().getCorpIDByCalBodyID(vo.getPk_org()));
      vo.setCorpvid(context.getOrgInfo().getCorpVIDByCalBodyID(vo.getPk_org()));
    }

    if (StringUtil.isSEmptyOrNull(vo.getCtrantypeid())) {
      // uapֵ֧͵ķ룬ʱԽcodeѯidķʽ
      String vtrantypecode = vo.getVtrantypecode();
      Map<String, String> map =
          PfServiceScmUtil.getTrantypeidByCode(new String[] {
            vtrantypecode
          });
      vo.setCtrantypeid(map == null ? null : map.get(vtrantypecode));
    }

  }

  /**
   * ݱ崦
   * 
   * @param vo
   * @param context
   * @throws BusinessException
   */
  private void bodyVOProcess(ICBillVO vo, ICBSContext context)
      throws BusinessException {
    ICBillBodyVO[] vos = vo.getBodys();
    if (ValueCheckUtil.isNullORZeroLength(vos))
      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
          .getStrByID("4008001_0", "04008001-0141")/*@res "ݱ岻Ϊ"*/);

    VORowNoUtils.setVOsRowNoByRule(vos, ICPubMetaNameConst.CROWNO);// кŴ

    ICBillHeadVO head = vo.getHead();
    for (ICBillBodyVO body : vos) {
      body.setStatus(VOStatus.NEW);
      if (StringUtil.isSEmptyOrNull(body.getCmaterialoid())
          || StringUtil.isSEmptyOrNull(body.getCmaterialvid()))
        throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
            .getStrByID("4008001_0", "04008001-0142")/*@res "ݱϲΪ"*/);

      body.setBbarcodeclose(UFBoolean.FALSE);// Ƿر
      body.setBonroadflag(UFBoolean.FALSE);// Ƿ;
      if (body.getDbizdate() == null)
        body.setDbizdate(context.getBizDate());// ҵ
      // λ
      if (StringUtil.isSEmptyOrNull(body.getCastunitid()))
        body.setCastunitid(context.getInvInfo()
            .getInvBasVO(body.getCmaterialvid()).getPk_stockmeas());

      bodyVOCopyFromHeadVO(body, head);

    }

  }

  /**
   * ݱͷñĬֵ弯ţ֯˾ֿ⣬
   * 
   * @param body
   * @param head
   */
  private void bodyVOCopyFromHeadVO(ICBillBodyVO body, ICBillHeadVO head) {
    body.setPk_group(head.getPk_group());
    body.setPk_org(head.getPk_org());
    body.setPk_org_v(head.getPk_org_v());
    body.setCorpoid(head.getCorpoid());
    body.setCorpvid(head.getCorpvid());
    body.setCbodywarehouseid(head.getCwarehouseid());
    body.setCbodytranstypecode(head.getVtrantypecode());
  }

  /**
   * Ƿ
   * 
   * @return
   */
  protected boolean canUpdate() {
    return false;
  }
  
  /**
   * voǷɸ
   * 
   * @param vo
   */
  protected void checkCanInster(AggregatedValueObject vo) {
    this.checkBillFlag(vo);
    new CheckMnyUtil().checkMny(vo);
    new CheckScaleUtil().checkScale(vo);
  }

  
  /**
   * vo״̬
   * 
   * @param vo
   */
  private void checkBillFlag(AggregatedValueObject vo) {
    if (!Integer.valueOf(ICBillFlag.getFreeFlag()).equals(
        vo.getParentVO().getAttributeValue(this.getBillStatusKey()))) {
      ExceptionUtils.wrappBusinessException(nc.vo.ml.NCLangRes4VoTransl
          .getNCLangRes().getStrByID("4008001_0", "04008001-0816")/*
                                                                   * @res
                                                                   * "̬ĵݲ룡"
                                                                   */);
    }
  }
  
  protected String getBillStatusKey() {
    return ICPubMetaNameConst.FBILLFLAG;
  }

  /**
   * 
   * ѯ
   * 
   * @param pk_material
   * @return
   * @throws BusinessException
   */
  private  Object  getbzjinfo(String pk_material,String pk_org) throws BusinessException{
	StringBuilder sb=new StringBuilder();  
	sb.append("  select qualitynum  from  bd_materialstock where  pk_material ='" + pk_material + "'  and pk_org ='" + pk_org + "' ");
	return obtaindb(sb.toString());
	  
  }
  
  public Object obtaindb(String sql) {
	  IUAPQueryBS iuapbs=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  Object als = null;
		if ((sql != null) && (!sql.equals(""))) {
			try {
				als = iuapbs.executeQuery(sql, new ColumnProcessor());
			} catch (BusinessException e) {
				e.printStackTrace();
			}
		}
		return als;
	}
  
  /**
   * ˰ϼ
   * @param pk_group 
   * @param nqtorigtaxprices ˰
   * @param nassistnum 
   * @param corigcurrencyid 
   * @return
   */
  public UFDouble bodydisposenorigtaxmny(String pk_group,UFDouble nqtorigtaxprices,UFDouble nassistnum,String corigcurrencyid){
	  ScaleUtils scale = new ScaleUtils(pk_group);
	  UFDouble nqtorigtaxprice = nqtorigtaxprices;//˰
	  UFDouble num = nassistnum;//
	  UFDouble norigtaxmny = CalculatorUtil.multiply(nqtorigtaxprice, num);
	  String curr = corigcurrencyid;//
	  norigtaxmny = scale.adjustMnyScale(norigtaxmny, curr);
	  return norigtaxmny;
  }
  
  /**
   * ˰
   * @param pk_group 
   * @param nqtorigtaxprices ˰
   * @param ntaxrate ˰
   * @param nassistnum 
   * @param corigcurrencyid 
   * @return
   */
  public UFDouble bodydisposenorigmny(String pk_group,UFDouble nqtorigtaxprices,UFDouble ntaxrate,UFDouble nassistnum,String corigcurrencyid){
	  UFDouble value = null;
	  ScaleUtils scale = new ScaleUtils(pk_group);
	  UFDouble norigtaxmny = bodydisposenorigtaxmny(pk_group, nqtorigtaxprices, nassistnum, corigcurrencyid);//˰ϼ
	  value = ntaxrate;//˰
	  value = CalculatorUtil.div(value, new UFDouble(100.0));
	  UFDouble d = UFDouble.ONE_DBL;
	  d = CalculatorUtil.add(d, value);
	  value = CalculatorUtil.div(norigtaxmny, d);
	  String curr = corigcurrencyid;//
	  value = scale.adjustMnyScale(value, curr);
	  return value;
  }
  
  /**
   * ɹϰ汾һ
   * @param pk_material 
   * @return
   */
  public Object disposeMaterialVersions(String pk_material){
	  StringBuffer sb = new StringBuffer();
	  sb.append("select pk_material from bd_material where latest = 'Y' and code in (select code from bd_material where pk_material = '"+pk_material+"')");
	  return obtaindb(sb.toString());
  }
  
  /**
   * ɹϰ汾һ
   * @param pk_material 
   * @return
   */
  public Object disposeMaterialVersions2(String pk_material){
	  StringBuffer sb = new StringBuffer();
	  sb.append("select pk_source from bd_material where latest = 'Y' and code in (select code from bd_material where pk_material = '"+pk_material+"')");
	  return obtaindb(sb.toString());
  }
  
  /**
   * λ
   * @param pk_stordoc ֿ
   * @param pk_org	֯
   * @param pk_rack	λ
   * @return
   */
  public Object bodytranslaterack(String pk_stordoc,String pk_org,String pk_rack)throws BusinessException{
	  StringBuffer sb = new StringBuffer();
	  sb.append("select pk_rack from bd_rack where pk_stordoc = '"+pk_stordoc+"' and pk_org = '"+pk_org+"' and code in (select code from bd_rack where  pk_rack = '"+pk_rack+"' and pk_org = '"+pk_org+"')");
	  return obtaindb(sb.toString());
  }
  
  /**
   * ȡPK
   * @param vbillcode 
   * @return
   */
  public Object setCbmoid(String vbillcode){
  	StringBuffer sb = new StringBuffer();
    	sb.append(" select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"'");
  	sb.append(" and nvl(dr,0) = 0");
  	return this.obtaindb(sb.toString());
  }
  
  /**
   * ȡPK
   * @param vbillcode 
   * @return
   */
  public Object setCbmobid(String vbillcode){
  	StringBuffer sb = new StringBuffer();
    	sb.append(" select cmoid from mm_mo where cpmohid ");
    	sb.append(" in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0) ");
  	sb.append(" and nvl(dr,0) = 0");
  	return this.obtaindb(sb.toString());
  }
  
  /*
  * ȡϼƻͷ
  * @param vbillcode 
  * @return
  */
 public Object setMm_pickmPK(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select cpickmid from mm_pickm ");
   	sb.append(" where vfirstmoid in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)");
 	sb.append(" and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
 
 /*
  * ȡϼƻ
  * @param vbillcode 
  * @return
  */
 public Object setPickmvbillcode(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select vbillcode from mm_pickm ");
   	sb.append(" where vfirstmoid in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)");
 	sb.append(" and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
 
 /*
  * ȡϼƻͱ
  * @param vbillcode 
  * @return
  */
 public Object setPickmvbusitype(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select vbusitypeid from mm_pickm ");
   	sb.append(" where vfirstmoid in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)");
 	sb.append(" and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
  
 /*
  * ȡϼƻ
  * @param vbillcode 
  * @return
  */
 public Object setPickm_bPK(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select cpickm_bid from mm_pickm_b where");
   	sb.append(" cpickmid in (select cpickmid from mm_pickm where ");
   	sb.append(" vfirstmoid in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)) ");
 	sb.append(" and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
 
 /*
  * ȡϼƻк
  * @param vbillcode 
  * @return
  */
 public Object setPickm_bvrowno(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select vrowno from mm_pickm_b where");
   	sb.append(" cpickmid in (select cpickmid from mm_pickm where ");
   	sb.append(" vfirstmoid in (select cpmohid from mm_pmo where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)) ");
 	sb.append(" and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
 
 /*
  * ȡͷ
  * @param vbillcode 
  * @return
  */
 public Object setMm_wrPK(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select pk_wr from mm_wr where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0");
 	return this.obtaindb(sb.toString());
 }
 
 /*
  * ȡ
  * @param vbillcode 
  * @return
  */
 public Object setMm_wr_productPK(String vbillcode){
 	StringBuffer sb = new StringBuffer();
   	sb.append(" select pk_wr_product from mm_wr_product");
   	sb.append(" where pk_wr in (select pk_wr from mm_wr where vbillcode = '"+vbillcode+"' and nvl(dr,0) = 0)");
 	return this.obtaindb(sb.toString());
 }
 
  
}
